\section{Concluding Remarks}
\label{sec:concl}
We conclude with a few closing remarks. We have presented a formal system for modeling the temporal
properties of a restricted class of real-time parallel systems, with a simple example of an 
application kernel. 
As is usually the case with real-time systems, 
loops need to be unrolled, bounding the number of iterations, in order 
to obtain an upper bound on the total execution time of the loop. 
Algorithm~\ref{algo:mm} (intentionally) distills to a relatively simple PTS, due to the basic structure
of the control flow graph of both the parent and child processes; more complex 
examples are of obvious interest for future work.
Similarly, the model in Figure~\ref{pts:mm} in our case was derived manually--- in this case,
a relatively simple task. More complex examples can certainly prove to be more of a challenge,
and automated tools for this task are desirable. One possible approach for such automation
would be compiler-driven, whereby users could specify to the compiler (via {\tt \#pragma}s, 
for instance), events of interest, and the compiler could proceed to output the appropriate
annotated control flow graph. 

We assume timing behavior is consistent across all child processes, although if there were to
be significant variance across child processes (e.g. heterogeneous or NUMA architectures) we 
could account for such behavior using different child TFAs.
%

Additionally, we have laid out several interesting open questions 
which arise out of the analysis of our relatively straightforward formulation: 
what is the complexity of computing the worst case delay along a single path of a TFA (TBA), and
through a TFA (TBA) in general?  Up to this point, we have only considered conjunctions of
maximum constraints; how does this change in the presence of a more generalized constraint
syntax (c.f. \cite{tba})?


We have largely been working with the SPMD execution model paradigmatic
of many MPI-type programs.  It would be interesting to investigate temporal models for 
other parallel models (e.g. OpenMP) as well.
Lastly, our application kernel distills to a 
relatively simple set of automata. More complex examples are certainly of interest, and
are on the horizon for future work. 

\endinput
